safe_time = 5
if safe_time == 0 then
  safe_time = 0.001
end

----------------------------------------------------------------------------------------------------
local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
----------------------------------------------------------------------------------------------------
-------------------------------------
function get_script_path() -- script_path and name from reaper function
  local filename = select(2, reaper.get_action_context())
  local script_path, script_name = filename:match("^(.*)[\\/](.+)")
  return script_path, script_name
end
----------
function get_exe_res_proj_pathes() -- exe, resources, project pathes
  local exe_path = reaper.GetExePath()
  local resource_path = reaper.GetResourcePath("")
  local project_path = reaper.GetProjectPath("")
  return exe_path, resource_path, project_path
end
----------
function modify_package_path(new_path) -- add new path to package.path
  package.path = package.path .. ";" .. new_path .. "/?.lua"
end
-- Get pathes -------------------------------------
local script_path, script_name = get_script_path()
local exe_path, resource_path, project_path = get_exe_res_proj_pathes()
-- Add script path to package.path
modify_package_path(script_path)

function tableToString(table)
  local str = ""
end

-- Load modules ----------------------------------
local Presets = require "Modules.Presets"
local File = require "Modules.File"
local json = require "Modules.json"


-- Save-------------------------------------------
function SaveRegionPreset(presetname)
  local str = json.encode(RegionName)
  if str then
    return Presets.Save(presetname, str) -- пишем данные в пресет
  end
end

function LoadRegionPreset(presetname)
  local presetdata = Presets.Load(presetname)
  RegionName = json.decode(presetdata)
  if presetdata then
    return true
  end
end

function SavePlayListTXT(presetname)
  local presetname = presetname
  PlayListdata = {}
  data_time = [[Наименование Проекта  : ]]..ProjectName.."\r".."\n"
  data_time = data_time..[[Общее время Концертной программы  : ]]..ShowTime.."\r"

  table.insert(PlayListdata, data_time)
  for i=1,  #RegionUse do
    local RegionUseName = Utf8ToAnsi(RegionUse[i].SongName)

    if compose_name_max == nil then
      compose_name_max = string.len(RegionUseName)   -- записываем длину самого длинного наименования
    else
      if string.len(RegionUseName) > compose_name_max then
        compose_name_max = string.len(RegionUseName) -- записываем длину самого длинного наименования
      end
    end
  end

  for i=1, #RegionUse do
    local Index = RegionUse[i].Index
    local ComposeTime = RegionUse[i].ComposeTime
    local ComposeName = RegionUse[i].SongName

    local ComposeName_len = string.len(Utf8ToAnsi(RegionUse[i].SongName))

    if RegionUse[i].ComposeCombine == true then
      data_compose = Index..".  "..ComposeName
      for i=1, (compose_name_max - ComposeName_len)  do
        data_compose = data_compose .. ' '
      end
      data_compose = data_compose .." || "..ComposeTime.." || Следующая проиграется сходу".."\r"
    else
      data_compose = Index..".  "..ComposeName
      for i=1, (compose_name_max - ComposeName_len) do
        data_compose = data_compose .. ' '
      end
      data_compose = data_compose .." || "..ComposeTime.." || Стоп".."\r"
    end
    table.insert(PlayListdata, data_compose)
  end

  data_poj_path = " ".."\r"
  table.insert(PlayListdata, data_poj_path)
  data_poj_path = ProjectPathName.."\r"
  table.insert(PlayListdata, data_poj_path)
  PlayListFile = PresettDir.."/Presets/"..presetname..".txt"

  File.WriteBin(PlayListFile, table.concat( PlayListdata, "\n" )) -- записываем в папку с Пресетами копию их Проекта
end

----------------------------------------------------------------------------------------------------
preset_update = 0

function PresetsDraw()
  -- MenuDraw return action and name(or nil)!
  local action, presetname = Presets.MenuDraw()
  --------------------------------------
  if action == "Load" then
    if LoadRegionPreset(presetname) then
      Presets.SetCurPresetName(presetname)

    end
  elseif action == "Save" then
    if SaveRegionPreset(presetname) then
      Presets.UpdateList() -- Update presets List
      Presets.SetCurPresetName(presetname)
    end
  elseif action == "Rename" then
    if Presets.Rename(Presets.curpresetname, presetname) then
      Presets.UpdateList() -- Update presets List
      Presets.SetCurPresetName(presetname)
    end
  elseif action == "Delete" then
    if Presets.Delete(presetname) then
      Presets.UpdateList() -- Update presets List
      Presets.SetCurPresetName()
    end
  end

  if preset_update == 0 then
    RegionNameLoad = {}
    RegionNameLoadNew = {}
    Presets.UpdateList()
    for i=1, #Presets.List do
      local presetname = Presets.List[i]
      local presetdata = Presets.Load(presetname)
      RegionNameLoad = json.decode(presetdata)
      if presetdata then
        if #RegionNameLoad < #RegionInit then
          for y=1, #RegionInit do
            if y<#RegionNameLoad then
              table.insert(RegionNameLoadNew, {Index = RegionNameLoad[y].Index, ID = RegionNameLoad[y].Index, SongName = RegionNameLoad[y].SongName, ComposeTime = RegionNameLoad[y].ComposeTime, ComposeStart = RegionNameLoad[y].ComposeStart, ComposeEnd = RegionNameLoad[y].ComposeEnd, ComposeCombine = RegionNameLoad[y].ComposeCombine, ComposeUse = RegionNameLoad[y].ComposeUse})
            else
              table.insert(RegionNameLoadNew, {Index = RegionInit[y].Index, ID = RegionInit[y].Index, SongName = RegionInit[y].SongName, ComposeTime = RegionInit[y].ComposeTime, ComposeStart = RegionInit[y].ComposeStart, ComposeEnd = RegionInit[y].ComposeEnd, ComposeCombine = RegionInit[y].ComposeCombine, ComposeUse = RegionInit[y].ComposeUse})
            end
          end
          RegionOldReSave = RegionNameLoadNew
          local str = json.encode(RegionOldReSave)
          if str then
            return Presets.Save(presetname, str) -- пишем данные в пресет
          end

        elseif #RegionNameLoad > #RegionInit then
          mesg = [[Один из ваших Пресетов: а именно -
          ]]..presetname.."\n"..[[
          создавался в проекте, в котором было больше
          Композиций, чем в текущемй -
          или не используйте этот Пресет,
          или отыщите ТОТ проект]]
          fff = reaper.MB(mesg , "ПРОЧТИТЕ ВНИМАТЕЛЬНО", 4)
        end
      end
    end
    preset_update = 1
  end
end



function SetRGB(RGB, a)
  gfx.r = (RGB & 0xFF0000) / 16711680 -- 256*256*255
  gfx.g = (RGB & 0x00FF00) / 65280 -- 256*255
  gfx.b = (RGB & 0x0000FF) / 255 -- 255
  gfx.a = a or 1
end

function InitMouse()
  mouse_last_cap = 0
  mouse_down_x, mouse_down_y = 0, 0
  mouse_last_x, mouse_last_y = 0, 0
  mouse_captimer = 0
end

function round(x)
  if x < 0 then return math.ceil(x - 0.5) else return math.floor(x + 0.5) end
end
----------------------------------------------------------------------------------------------------
function InitGUI (crm, w_rn_new)
  h_s = 30 -- высота строк
  h_cup = 150 -- высота шапки GUI до списка
  w_n = 10+w_rn_new+10 -- ширина ячейи под имя композиции
  w_gui = 20+(h_s+2)*7+w_n -- ширина GUI
  h_gui_full = #RegionName*(h_s+2)+h_cup+10
  if crm >= 15 then
    h_gui = 15*(h_s+2)+h_cup+10 -- высота GUI ограниченная 15-ю строками
  else
    h_gui = crm*(h_s+2)+h_cup+10 -- высота GUI ограниченная 15-ю строками
  end

  gfx.init("GUI Concert List", w_gui,
  tonumber(reaper.GetExtState("GUI_Coord","wndh")) or h_gui,
  tonumber(reaper.GetExtState("GUI_Coord","dock")) or 0,
  tonumber(reaper.GetExtState("GUI_Coord","wndx")) or 900,
  tonumber(reaper.GetExtState("GUI_Coord","wndy")) or 400)
  --------------------
  -- gfx.clear = 0x0f0f0f -- bg color, BBGGRR
  -- gfx.clear = 0x333333 -- bg color, BBGGRR
  gfx.clear = 0x202020 -- bg color, BBGGRR
  --------------------
  InitMouse()
  -- Preset path, ext ----------
  preset_path = script_path .. "/ConcertPresets"
  preset_ext = "SetList" -- preset extension
  Presets.MenuInit(10,10,w_gui-20,30, 0xffe400, 0xffe400, preset_path, preset_ext, 16)
  mainloop() -- Запускаем осн. луп
end

function Quit()
  d,x,y,w,h=gfx.dock(-1,0,0,0,0)
  reaper.SetExtState("GUI_Coord","wndh",h,true)
  reaper.SetExtState("GUI_Coord","dock",d,true)
  reaper.SetExtState("GUI_Coord","wndx",x,true)
  reaper.SetExtState("GUI_Coord","wndy",y,true)
  gfx.quit()
end
reaper.atexit(Quit)

function EmptyRegionAndName ()
  Empty = 0
  suf = 0
  new_element = false
  local CountAllMarkers = ({reaper.CountProjectMarkers(0)})[2]+({reaper.CountProjectMarkers(0)})[3]
  local length_project = reaper.GetProjectLength(0)
  for i=1, CountAllMarkers do
    local region_name = ({reaper.EnumProjectMarkers(i-1)})[5]
    local RegionMarkers = ({reaper.EnumProjectMarkers(i-1)})[2]
    if RegionMarkers == true then
      if region_name == "!!!Empty" then
        Empty = 1
      end
    end
  end

  if Empty == 0 then
    reaper.AddProjectMarker(0, 1, length_project+200, length_project+210, "!!!Empty", 5)
    Empty = 1
  end

  local CountAllMarkers = ({reaper.CountProjectMarkers(0)})[2]+({reaper.CountProjectMarkers(0)})[3]
  for i=1, CountAllMarkers do
    local retval, RegionMarkers, pos, rgnend, region_name, indx = reaper.EnumProjectMarkers2(0, i-1)
    if region_name == "" then
      suf = suf+1
      local name_s = "No Name 0"..suf
      reaper.SetProjectMarker(indx, RegionMarkers, pos, rgnend, name_s)
      new_element = true
    end
  end

  reaper.Main_OnCommand(reaper.NamedCommandLookup("_SWSMARKERLIST8"), 0) --SWS: Renumber region IDs
end

function Init()
  EmptyRegionAndName ()
  local CountRegionMarkers = ({reaper.CountProjectMarkers(0)})[3]
  if CountRegionMarkers == 0 then return end -- скрипт не работает, если нет ни одного Региона
  ---------------------------------------------------------------
  RegionInit = {}
  RegionName = {}
  RegionCoordinates = {}
  RegionCapture = {}
  SongNameUp = nil
  local OS = reaper.GetOS()
  if OS == "OSX64"  then
    f_s = 16 -- размер фонта
  else
    f_s = 18 -- размер фонта
  end
  s_position = 1 -- initial scroll position
  one_hand = false -- не использовать одну руку для управления!
  gfx.setfont(1,"Verdana",f_s)
  local CountAllMarkers = ({reaper.CountProjectMarkers(0)})[2]+({reaper.CountProjectMarkers(0)})[3]
  for i=1, CountAllMarkers do
    RegionMarkers = ({reaper.EnumProjectMarkers(i-1)})[2]
    if RegionMarkers == true then
      local region_name = ({reaper.EnumProjectMarkers(i-1)})[5]
      local id_region = ({reaper.EnumProjectMarkers2( 0, i-1 )})[6]
      local retval, isrgn, pos, rgnend, name, markrgnindexnumber = reaper.EnumProjectMarkers2(0, i-1)
      local c_time = rgnend - pos
      local compose_time = reaper.format_timestr_pos(c_time, '', 5)
      local compose_time = string.sub(compose_time,3,-1)
      local compose_combine = false
      local compose_use = false

      local w_rn = gfx.measurestr(region_name)
      if w_rn <= 100 then
        w_rn = 100
      end

      if w_rn_new == nil then
        w_rn_new = w_rn   -- записываем длину самого длинного наименования
      else
        if w_rn > w_rn_new then
          w_rn_new = w_rn -- записываем длину самого длинного наименования
        end
      end

      table.insert(RegionInit, {Index = id_region, SongName = region_name, ComposeStart = pos, ComposeEnd = rgnend, ComposeTime = compose_time, ComposeCombine = compose_combine, ComposeUse = compose_use})
    end
  end

  idx = 0
  for z=1, #RegionInit do
    for y=1, #RegionInit do
      if RegionInit[y].Index == idx + 1 then
        idx = RegionInit[y].Index
        table.insert(RegionName, {Index = RegionInit[y].Index, ID = RegionInit[y].Index, SongName = RegionInit[y].SongName, ComposeTime = RegionInit[y].ComposeTime, ComposeStart = RegionInit[y].ComposeStart, ComposeEnd = RegionInit[y].ComposeEnd, ComposeCombine = RegionInit[y].ComposeCombine, ComposeUse = RegionInit[y].ComposeUse})
        id_select = 0
        table.insert(RegionCoordinates, {ID = id_select})
      end
    end
  end
  InitGUI (CountRegionMarkers, w_rn_new)
end

----------------------------------------------------------------------------------------------------
function GetMouse()
  -- mouse state -----------------------
  mouse_down = gfx.mouse_cap&1==1 and mouse_last_cap&1==0
  mouse_up = gfx.mouse_cap&1==0 and mouse_last_cap&1==1

  if mouse_down then mouse_down_x, mouse_down_y = gfx.mouse_x, gfx.mouse_y end
  if mouse_up then mouse_up_x, mouse_up_y = gfx.mouse_x, gfx.mouse_y end

  mouse_move = (mouse_last_x ~= gfx.mouse_x) or (mouse_last_y ~= gfx.mouse_y)
  mouse_move_up = (mouse_last_y > gfx.mouse_y)
  mouse_move_down = (mouse_last_y < gfx.mouse_y)
end
------------------------------------------------------------------------------------
function timeout(towait, var, time1)
  if time1 == nil or time1 == 0 then
    time1 = reaper.time_precise()
  end

  time2 = reaper.time_precise()
  diff = time2 - time1
  if diff < towait then
    reaper.defer(function()
      timeout(towait, var, time1)
    end)
  else
    var()
  end
end
------------------------------------------------------------------------------------
function UpdateMouse()
  -- update mouse last state -----------
  mouse_last_cap = gfx.mouse_cap
  mouse_last_x = gfx.mouse_x
  mouse_last_y = gfx.mouse_y
  gfx.mouse_wheel = 0
  gfx.mouse_hwheel = 0
end
----------------------------------------------------------------------------------------------------

function pointIN(px, py, x,y,w,h)
  return px >= x and px <= x + w and py >= y and py <= y + h
end
----------------------------------------
function mouseIN(x,y,w,h)
  return pointIN(gfx.mouse_x, gfx.mouse_y, x,y,w,h)
end
----------------------------------------
function mouseDown(x,y,w,h)
  return mouse_down and mouseIN(x,y,w,h)
end
----------------------------------------
function mouseUp(x,y,w,h)
  return mouse_up and mouseIN(x,y,w,h)
end
----------------------------------------
function mouseClick(x,y,w,h)
  return mouseUp(x,y,w,h) and pointIN(mouse_down_x,mouse_down_y, x,y,w,h)
end
----------------------------------------
click = 0
function DoubleMouseClick(x,y,w,h)
  if mouseClick(x,y,w,h) then
    click = click+1
  end
  if click == 1 then
    timeout(0.3,function ()
      click = 0
    end)
  end
  return click
end

----------------------------------------------------------------------------------------------------
function ScrollTo(delta)
  s_position = s_position + delta
end

function GetCursorRegion(time_pos, play_state)
  for i=1, #RegionName do
    local play_state = play_state
    local t_pos = time_pos
    if t_pos >= RegionName[i].ComposeStart and t_pos <= RegionName[i].ComposeEnd then
      id_t_pos = RegionName[i].Index
      if RegionCoordinates[id_t_pos].ID == 0 then
        for z=1,#RegionCoordinates do
          RegionCoordinates[z].ID = 0
        end
        RegionCoordinates[id_t_pos].ID = 1
      end
      if (play_state == 1 or play_state == 5) and RegionName[i].ComposeUse == false then
        reaper.OnStopButton()
      end
    end
  end
end

function PlayConcert ()
  local play_state = reaper.GetPlayState()
  local play_pos = reaper.GetPlayPosition()
  local cursor_pos = reaper.GetCursorPosition()
  local time_pos

  if play_state == 1 or play_state == 5 then
    time_pos = play_pos
    play = true
  end

  if play_state == 0 or play_state == 2 then
    time_pos = cursor_pos
  end

  GetCursorRegion(time_pos, play_state)

  for i=1, #RegionInit-1 do
    local play_region_name = RegionInit[i].SongName
    local rg_end = RegionInit[i].ComposeEnd
    if play == true and time_pos >= rg_end then
      local rg_start_next = RegionInit[i+1].ComposeStart
      if time_pos < rg_start_next then
        reaper.OnPauseButton()
        reaper.OnStopButton()
        for z=1, #RegionName do
          if RegionName[z].SongName == play_region_name then

            for c=RegionName[z].Index, #RegionName-1 do
              if RegionName[c+1].ComposeUse == true then
                next_id = c+1
                NextSongName = RegionName[next_id].SongName
                break
              else
                local c_time = RegionName[c].ComposeEnd - RegionName[c].ComposeStart
                local compose_time = reaper.format_timestr_pos(c_time, '', 5)
                local compose_time = string.sub(compose_time,3,-1)
                RegionName[c].ComposeTime = compose_time -- восстановление времени композиции после е\ проигрывания
                for i=1, #RegionName do
                  if RegionName[i].ComposeUse == true then
                    NextSongName = RegionName[i].SongName
                    break
                  end
                end
              end
            end

            local PlayNextNoPause = RegionName[z].ComposeCombine
            for y=1, #RegionInit do
              if NextSongName and RegionInit[y].SongName == NextSongName then
                next_ID = RegionInit[y].Index
                for b=1,#RegionCoordinates do
                  RegionCoordinates[b].ID = 0
                end
                RegionCoordinates[z+1].ID = 1
                reaper.GoToRegion(0, next_ID, true) --Seek to region after current region finishes playing (smooth seek)
                local cursor_pos = reaper.GetCursorPosition()
                reaper.MoveEditCursor(0.0005, false)
                -- msg(cursor_pos)
                local c_time = RegionName[z].ComposeEnd - RegionName[z].ComposeStart
                local compose_time = reaper.format_timestr_pos(c_time, '', 5)
                local compose_time = string.sub(compose_time,3,-1)
                RegionName[z].ComposeTime = compose_time -- восстановление времени композиции после е\ проигрывания
                if PlayNextNoPause == true then
                  reaper.OnPlayButton()
                end
              end
            end
          end
        end
        play = false
      end
    end
  end
end

function SongMove ()
  local x,y,w,h
  local scroll_delay = 0.07
  if RegionCapture.isCaptured then
    if mouseIN(10,0,gfx.w-20,(h_cup+10)) then
      if RegionCapture.waitingScroll ~= true then
        RegionCapture.waitingScroll = true
        timeout(scroll_delay,function ()
          if RegionCapture.isCaptured and RegionCapture.waitingScroll then
            ScrollTo(-1)
            RegionCapture.waitingScroll = false
          end
        end)
      end
    elseif mouseIN(10,(h_cup-10)+(h_s+2)*visibleRows,gfx.w-20,(h_cup+5)) then
      if RegionCapture.waitingScroll ~= true then
        RegionCapture.waitingScroll = true
        timeout(scroll_delay,function ()
          if RegionCapture.isCaptured and RegionCapture.waitingScroll then
            ScrollTo(1)
            RegionCapture.waitingScroll = false
          end
        end)
      end
    else
      RegionCapture.waitingScroll = false
    end
  end

  for i=s_position, visibleRows+s_position-1, 1 do
    x,y,w,h = RegionCoordinates[i].x, RegionCoordinates[i].y, RegionCoordinates[i].w, RegionCoordinates[i].h

    if DoubleMouseClick(x, y, w_n, h) == 2 and RegionName[i].ComposeUse == true then
      reaper.OnStopButton()
      local play_state = reaper.GetPlayState()
      -- if play_state == 0 or play_state == 2 then
      for i=1,#RegionCoordinates do
        RegionCoordinates[i].ID = 0
      end
      RegionCoordinates[i].ID = 1 -- выделяем композицию для плэя
      local next_ID_DC = RegionName[i].ID
      reaper.GoToRegion(0, next_ID_DC, true) --Seek to region after current region finishes playing (smooth seek)
      -- local cursor_pos = reaper.GetCursorPosition()
      reaper.MoveEditCursor(0.0005, false)
      -- end
      click = 0
    end

    if RegionCoordinates[i].ID == 1 and RegionName[i].ComposeUse == true then
      DrawSelCompose (10, y, w_n+h*5+6, h, 1)
    else
      DrawSelCompose (10, y, w_n+h*5+6, h, 0)
    end

    if mouseDown(x,y,w,h) and y < h_gui_full then RegionCapture.isCaptured = true end -- set cap state
    if RegionCapture.isCaptured and mouse_up then RegionCapture.isCaptured = false end  -- reset cap state

    if mouseIN(x,y,w,h) and y < h_gui_full then -- нужно для работы только в зоне 15-и строк
      if mouseDown(x,y,w,h) then
        IdDown = RegionName[i].ID
        SongNameDown = RegionName[i].SongName
        IndexDown = RegionName[i].Index
        ComposeTimeDown = RegionName[i].ComposeTime
        ComposeStartDown = RegionName[i].ComposeStart
        ComposeEndDown = RegionName[i].ComposeEnd
        ComposeUseDown = RegionName[i].ComposeUse
        ComposeCombineDown = RegionName[i].ComposeCombine
      end

      if mouseUp(x,y,w,h) and SongNameDown then -- если нет SongNameDown то и SongNameUp не получать
        SongNameUp = RegionName[i].SongName
        IndexUp = RegionName[i].Index
      end

      if RegionCapture.isCaptured then
        if mouse_move == true then
          SetRGB(0x0f0f0f, 1)
          gfx.rect(x, y, w, h, 1) -- зарисовываем прямоугольник под мышкой
          SetRGB(0xdbfb02, 0.5)
          gfx.x, gfx.y = 10+4+h*2, gfx.mouse_y - h/4
          gfx.drawstr(SongNameDown, 5, gfx.x+w, gfx.y+h) -- пишем строку
        end

        if mouse_move == false then
          SetRGB(0x0f0f0f, 0.5)
          gfx.rect(x, y, w, h, 1)  -- зарисовываем прямоугольник под мышкой
          SetRGB(0xcffb02, 0.8)
          gfx.x, gfx.y = 10+4+h*2, gfx.mouse_y - h/4
          gfx.drawstr(SongNameDown, 5, gfx.x+w, gfx.y+h) -- пишем строку
        end
      end
    end
  end

  if mouse_up then -- нужно чтоб перемещение композиций работало только в заданной зоне
    if mouse_up_x < (h_s+2)*2+10 or mouse_up_x > (h_s+2)*2+10+w_n+2 or
    mouse_up_y < h_cup or mouse_up_y > h_gui_full then -- если мышь отпустили вне рабочей зоны
      SongNameDown = nil -- вытираем имя композиции на которой мы нажали мышь
    end
  end

  if SongNameUp and SongNameDown then
    if IndexUp < IndexDown then
      for i=#RegionName, 1, -1 do -- прохождение цикла в обратном порядке
        if RegionName[i].Index > IndexUp and i <= IndexDown then
          RegionName[i].ID = RegionName[i-1].ID
          RegionName[i].SongName = RegionName[i-1].SongName
          RegionName[i].ComposeTime = RegionName[i-1].ComposeTime
          RegionName[i].ComposeStart = RegionName[i-1].ComposeStart
          RegionName[i].ComposeEnd = RegionName[i-1].ComposeEnd
          RegionName[i].ComposeUse = RegionName[i-1].ComposeUse
          RegionName[i].ComposeCombine = RegionName[i-1].ComposeCombine
        end
      end
      RegionName[IndexUp].ID = IdDown
      RegionName[IndexUp].SongName = SongNameDown
      RegionName[IndexUp].ComposeTime = ComposeTimeDown
      RegionName[IndexUp].ComposeStart = ComposeStartDown
      RegionName[IndexUp].ComposeEnd = ComposeEndDown
      RegionName[IndexUp].ComposeUse = ComposeUseDown
      RegionName[IndexUp].ComposeCombine = false -- снимаем объединение с перетаскиваемой композиции
    end

    if mouse_up_y < h_gui_full then -- нужно для ограничения 15 строк
      if IndexUp > IndexDown then
        for i=1, #RegionName do
          if RegionName[i].Index > IndexDown and i <= IndexUp then
            RegionName[i-1].ID = RegionName[i].ID
            RegionName[i-1].SongName = RegionName[i].SongName
            RegionName[i-1].ComposeTime = RegionName[i].ComposeTime
            RegionName[i-1].ComposeStart = RegionName[i].ComposeStart
            RegionName[i-1].ComposeEnd = RegionName[i].ComposeEnd
            RegionName[i-1].ComposeUse = RegionName[i].ComposeUse
            RegionName[i-1].ComposeCombine = RegionName[i].ComposeCombine
          end
        end
        RegionName[IndexUp].ID = IdDown
        RegionName[IndexUp].SongName = SongNameDown
        RegionName[IndexUp].ComposeTime = ComposeTimeDown
        RegionName[IndexUp].ComposeStart = ComposeStartDown
        RegionName[IndexUp].ComposeEnd = ComposeEndDown
        RegionName[IndexUp].ComposeUse = ComposeUseDown
        RegionName[IndexUp].ComposeCombine = false -- снимаем объединение с перетаскиваемой композиции
      end
    end
    SongNameDown = nil
    SongNameUp = nil
  end
  Header()
end

function DrawRectStr (x, y, w, h, i, flag)
  if i then
    SetRGB(0x36ff00, 0.85)
    gfx.x, gfx.y = x, y
    gfx.drawstr(tostring(i), flag, gfx.x + w, gfx.y + h) -- пишем строку
  else
    SetRGB(0xffe400,0.35)
    gfx.rect(x, y, w, h, 0) -- рисуем прямоугольник
  end
end

function DrawSelCompose (x, y, w, h, a)
  SetRGB(0xffe400,a)
  gfx.rect(x, y, w, h, 0) -- рисуем прямоугольник
end

function DrawMoveCompose (x, y, w, h, i, flag)
  SetRGB(0xfff33e,0.5)
  gfx.x, gfx.y = x, y
  gfx.drawstr(tostring(i), flag, gfx.x + w, gfx.y + h) -- пишем строку
end

function DrawTimeStr (x, y, w, h, i, flag)
  if i then
    SetRGB(0xffffff, 0.7)
    gfx.x, gfx.y = x, y
    gfx.drawstr(tostring(i), flag, gfx.x + w, gfx.y + h) -- пишем строку
  end
end

function DrawUsetStr (x, y, w, h, i, flag)
  if i then
    SetRGB(0xffffff, 0.7)
    gfx.x, gfx.y = x, y
    gfx.drawstr(tostring(i), flag, gfx.x + w, gfx.y + h) -- пишем строку
  end
end

function Header()
  local play_state = reaper.GetPlayState()
  local play_pos = reaper.GetPlayPosition()
  local cursor_pos = reaper.GetCursorPosition()
  local time_pos
  if play_state == 1 or play_state == 5 then
    time_pos = play_pos
    play = true
  end

  if play_state == 0 or play_state == 2 then
    time_pos = cursor_pos
  end
  local OS = reaper.GetOS()
  if OS == "OSX64"  then
    gfx.setfont(1,"Verdana",14)
  else
    gfx.setfont(1,"Verdana",17)
  end

  local SongPlay = [[Play Compos  :  ]]
  local NextPlay = [[Next Compos :  ]]
  gfx.x, gfx.y = 13, 0 -- начальные координаты надписи
  SetRGB(0xffffff, 0.5)
  gfx.drawstr(SongPlay, 4, gfx.x+w_gui, gfx.y+120)
  gfx.x, gfx.y = 12, 22 -- начальные координаты надписи
  gfx.drawstr(NextPlay, 4, gfx.x+w_gui, gfx.y+120)
  for i=1, #RegionUse do
    if RegionCoordinates[i].ID == 1 and RegionUse[i].ComposeUse == true then
      gfx.x, gfx.y = 132, 0 -- начальные координаты надписи
      if i==1 then
        SetRGB(0x36ff00, 0.75)
      else
        SetRGB(0xffffff, 0.75)
      end
      gfx.drawstr(RegionUse[i].SongName, 4, gfx.x+w_gui-h_s*3+16, gfx.y+120)

      gfx.x, gfx.y = 132,23 -- начальные координаты надписи
      if i < #RegionUse then
        if RegionUse[i+1].ComposeUse == true then
          SetRGB(0xffffff, 0.75)
          next_song = RegionUse[i+1].SongName
        elseif RegionUse[i].ComposeUse == true and RegionUse[i+1].ComposeUse == false and RegionUse[i].ComposeCombine == true then
          SetRGB(0x36ff00, 0.75)
          next_song = RegionUse[1].SongName
        end
      else
        if RegionUse[i].ComposeCombine == false then
          SetRGB(0xed1c24,0.75)
          next_song = "End of the Concert"
        else
          SetRGB(0x36ff00, 0.75)
          next_song = RegionUse[1].SongName
        end
      end
      gfx.drawstr(next_song, 4, gfx.x+w_gui-h_s*3+16, gfx.y+120)
    end
  end

  -- Show Time ------------------------------------------
  local ct_time, ct_left_time, sel_time, left_am_com, sel_index
  if #RegionUse == 0 then
    ct_time = 0
    ct_left_time = 0
    sel_time = 0
    left_am_com = "0"..0
    sel_index = 0
  else
    for i=1, #RegionUse do
      if i==1 then
        ct_time = 0
        ct_left_time = 0
        sel_time = 0
        sel_index = 0
        left_am_com = "0"..0
      end
      local comp_time = RegionUse[i].ComposeEnd-RegionUse[i].ComposeStart
      ct_time = ct_time+comp_time
      if RegionUse[i].Sel == 1 then
        sel_index = RegionUse[i].Index
        sel_time = time_pos - RegionUse[i].ComposeStart
      end
    end

    for i=1, #RegionUse do
      local comp_time = RegionUse[i].ComposeEnd-RegionUse[i].ComposeStart
      if sel_index and i>=sel_index then
        ct_left_time = ct_left_time + comp_time
      end
    end
    ct_left_time = ct_left_time - sel_time
    left_am_com = #RegionUse - sel_index
    if left_am_com <10 then
      left_am_com = "0"..left_am_com
    end
  end

  local ShowLeftTime = reaper.format_timestr_pos(ct_left_time, '', 5)
  local am_com = #RegionUse
  if am_com <10 then
    am_com = "0"..am_com
  end
  ShowTime = reaper.format_timestr_pos(ct_time, '', 5)

  if OS == "OSX64"  then
    gfx.setfont(1,"Verdana",14)
  else
    gfx.setfont(1,"Verdana",17)
  end
  gfx.x, gfx.y = 12, 35 -- начальные координаты надписи
  local info1 = [[Total Compos/Time :]]
  SetRGB(0xffffff, 0.5)
  gfx.drawstr(info1, 4, gfx.x+w_gui, gfx.y+150)
  gfx.x = gfx.x+5
  local info2 = am_com.." / "..tostring(ShowTime)
  SetRGB(0xffffff, 0.7)
  gfx.drawstr(info2, 4, gfx.x+w_gui+100, gfx.y+150)
  gfx.x, gfx.y = 15, 35 -- начальные координаты надписи
  local info3 = [[Left Compos/Time  :]]
  SetRGB(0xffffff, 0.5)
  gfx.drawstr(info3, 4, gfx.x+w_gui, gfx.y+190)
  gfx.x = gfx.x+5
  local info4 = left_am_com.." / "..tostring(ShowLeftTime)
  SetRGB(0xffffff, 0.7)
  gfx.drawstr(info4, 4, gfx.x+w_gui, gfx.y+190)

  ----------- Блок кнопки использования скрипта одной рукой с защитой по времени ---------------------
  local x, y, w, h = 10, h_cup, h_s, h_s
  if OS == "OSX64"  then
    gfx.setfont(1,"Verdana Bold", 11)
  else
    gfx.setfont(1,"Cooper Black", 15)
  end

  if mouseDown(x+(h_s+2)*5+w_n, y-45, w*2, h) and one_hand == false then
    timeout(safe_time,function ()
      one_hand = false
    end)
    one_hand = true
  elseif mouseDown(x+(h_s+2)*5+w_n, y-45, w*2, h) and one_hand == true then
    one_hand = false
  end

  if one_hand == true then
    SetRGB(0xed1c24,1)
    gfx.rect(x+(h_s+2)*5+w_n-4, y-46, w*2+6, h+2, 1) -- рисуем прямоугольник
    SetRGB(0xffffff, 1)
    gfx.x, gfx.y = x+(h_s+2)*5+w_n+0.5, y-67
    gfx.drawstr("One".."\n".."\n".."Hand", 5, gfx.x + w*2, gfx.y + h*2) -- пишем строку для использования скрипта одной рукой
  else
    SetRGB(0xffe400,0.35)
    gfx.rect(x+(h_s+2)*5+w_n-4, y-46, w*2+6, h+2, 0) -- рисуем прямоугольник
    SetRGB(0xffffff, 0.55)
    gfx.x, gfx.y = x+(h_s+2)*5+w_n+0.5, y-67
    gfx.drawstr("One".."\n".."\n".."Hand", 5, gfx.x + w*2, gfx.y + h*2) -- пишем строку для использования скрипта одной рукой
  end

end


function RefreshList ()
  RegionUse = {}
  RegionUnUse = {}
  Region = {}

  q = 0
  for i=1, #RegionName do
    if RegionName[i].ComposeUse == true then
      q=q+1
      table.insert(RegionUse, {Index = q, ID = RegionName[i].ID, SongName = RegionName[i].SongName, ComposeTime = RegionName[i].ComposeTime, ComposeStart = RegionName[i].ComposeStart, ComposeEnd = RegionName[i].ComposeEnd, ComposeCombine = RegionName[i].ComposeCombine, ComposeUse = RegionName[i].ComposeUse, Sel = RegionCoordinates[i].ID})
    end
  end

  g = 0
  for i=1, #RegionName do
    if RegionName[i].ComposeUse == false then
      g=g+1
      table.insert(RegionUnUse, {Index = g, ID = RegionName[i].ID, SongName = RegionName[i].SongName, ComposeTime = RegionName[i].ComposeTime, ComposeStart = RegionName[i].ComposeStart, ComposeEnd = RegionName[i].ComposeEnd, ComposeCombine = RegionName[i].ComposeCombine, ComposeUse = RegionName[i].ComposeUse})
    end
  end


  for i=1, #RegionUse do
    -- msg(RegionUse[i].Index.." : "..RegionUse[i].SongName)
    table.insert(Region, {Index = i, ID = RegionUse[i].ID, SongName = RegionUse[i].SongName, ComposeTime = RegionUse[i].ComposeTime, ComposeStart = RegionUse[i].ComposeStart, ComposeEnd = RegionUse[i].ComposeEnd, ComposeCombine = RegionUse[i].ComposeCombine, ComposeUse = RegionUse[i].ComposeUse})
  end

  for z=1+#RegionUse, #RegionUnUse+#RegionUse do
    i=z-#RegionUse
    table.insert(Region, {Index = z, ID = RegionUnUse[i].ID, SongName = RegionUnUse[i].SongName, ComposeTime = RegionUnUse[i].ComposeTime, ComposeStart = RegionUnUse[i].ComposeStart, ComposeEnd = RegionUnUse[i].ComposeEnd, ComposeCombine = RegionUnUse[i].ComposeCombine, ComposeUse = RegionUnUse[i].ComposeUse})

  end

  for i=1, #RegionName do
    RegionName[i].Index = Region[i].Index
    RegionName[i].ID = Region[i].ID
    RegionName[i].SongName = Region[i].SongName
    RegionName[i].ComposeTime = Region[i].ComposeTime
    RegionName[i].ComposeStart = Region[i].ComposeStart
    RegionName[i].ComposeEnd = Region[i].ComposeEnd
    RegionName[i].ComposeUse = Region[i].ComposeUse
    RegionName[i].ComposeCombine = Region[i].ComposeCombine
  end
end

function DrawRows ()
  x, y, w, h = 10, h_cup, h_s, h_s
  gfx.setfont(1,"Verdana",f_s)
  local play_state = reaper.GetPlayState()
  local play_pos = reaper.GetPlayPosition()
  local cursor_pos = reaper.GetCursorPosition()
  local time_pos
  if play_state == 1 or play_state == 5 then
    time_pos = play_pos
    play = true
  end

  if play_state == 0 or play_state == 2 then
    time_pos = cursor_pos
  end

  visibleRows = math.max(math.min(maxRowsFit, #RegionName), 1)

  for i=s_position, s_position+visibleRows-1, 1 do
    RegionCoordinates[i].x = x+(h_s+2)*2
    RegionCoordinates[i].y = y
    RegionCoordinates[i].w = w_n
    RegionCoordinates[i].h = h

    if RegionName[i].SongName ~= "!!!Empty" then
      if RegionCoordinates[i].ID == 1 and RegionName[i].ComposeUse == true then
        local w_n_time = w_n/(RegionName[i].ComposeEnd-RegionName[i].ComposeStart)*(time_pos-RegionName[i].ComposeStart)
        local comp_time = (RegionName[i].ComposeEnd-time_pos)
        local compose_time = reaper.format_timestr_pos(comp_time, '', 5)
        local compose_time = string.sub(compose_time,3,-1)
        RegionName[i].ComposeTime = compose_time
        SetRGB(0xffe400,0.2)
        gfx.rect(x+(h_s+2)*2, y, w_n_time, h, 1) -- рисуем прямоугольник
      end

      DrawRectStr (x, y, w, h) -- рисуем первый прямоугольник для ID
      DrawRectStr (x, y, w, h, RegionName[i].Index, 5) -- Пишем ID Региона
      DrawRectStr (x+h_s+2, y, w, h) -- рисуем второй прямоугольник для выбора участвующей в концерте

      if one_hand == false then
        if mouse_last_cap == 4 then -- чтоб случайно не нажать, жмём с Ctr
          if mouseDown (x+h_s+2, y, w, h) and RegionName[i].ComposeUse == false then
            RegionName[i].ComposeUse = true
          elseif mouseDown (x+h_s+2, y, w, h) and RegionName[i].ComposeUse == true then
            RegionName[i].ComposeUse = false
          end
        end
      else -- Если снята защита (кнопкой) то выбор лкм без Ctrl
        if mouseDown (x+h_s+2, y, w, h) and RegionName[i].ComposeUse == false then
          RegionName[i].ComposeUse = true
        elseif mouseDown (x+h_s+2, y, w, h) and RegionName[i].ComposeUse == true then
          RegionName[i].ComposeUse = false
        end
      end

      if mouse_last_cap == 8 then -- для выбора блока регионов, жмём с Shift
        for c=1, #RegionName do
          if RegionName[c].ComposeUse == true then
            last_us = RegionName[c].Index
          end
        end
        last_us = last_us
        if last_us then
          for d=1, #RegionName do
            if d>last_us and d<=i then
              if mouseDown (x+h_s+2, y, w, h) and RegionName[d].ComposeUse == false then
                RegionName[d].ComposeUse = true
              end
            end

            if d<=last_us and d>=i then
              if mouseDown (x+h_s+2, y, w, h) and RegionName[d].ComposeUse == true then
                RegionName[d].ComposeUse = false
              end
            end
          end
          last_us = nil
        else
          if mouseDown (x+h_s+2, y, w, h) and RegionName[i].ComposeUse == false then
            RegionName[i].ComposeUse = true
          end
        end
      end

      if RegionName[i].ComposeUse == true then
        DrawUsetStr (x+h_s+2, y, w, h, "+", 5) -- рисуем символ - используется или нет композиция
      end

      DrawRectStr (x+(h_s+2)*2, y, w_n, h) -- рисуем второй прямоугольник для имени композиции
      -- DrawRectStr (x+h_s*2, y, w_n, h, "  "..RegionName[i].ID.." - "..RegionName[i].SongName, 4) -- имя композиции
      if RegionName[i].SongName == SongNameDown then
        DrawMoveCompose (x+h_s*2, y, w_n, h, "  "..RegionName[i].SongName, 4) -- имя композиции
      else
        DrawRectStr (x+h_s*2, y, w_n, h, "  "..RegionName[i].SongName, 4) -- имя композиции
      end

      DrawRectStr (x+(h_s+2)*2+w_n+2, y, h_s*3, h) -- рисуем прямоугольник для времени композиции
      DrawTimeStr (x+(h_s+2)*2+w_n+2, y, h_s*3, h, RegionName[i].ComposeTime.."  ", 6) -- рисуем время композиции
      if i < s_position+visibleRows-1 then
        DrawRectStr (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) -- рисуем прямоугольник для объединения композиции

        if one_hand == false and RegionName[i].ComposeUse == true then
          if mouse_last_cap == 4 then
            if mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[i].ComposeCombine == false then
              RegionName[i].ComposeCombine = true
            elseif mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[i].ComposeCombine == true then
              RegionName[i].ComposeCombine = false
            end
          end
        elseif one_hand == true and RegionName[i].ComposeUse == true then
          if mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[i].ComposeCombine == false then
            RegionName[i].ComposeCombine = true
          elseif mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[i].ComposeCombine == true then
            RegionName[i].ComposeCombine = false
          end
        end

        if mouse_last_cap == 8 and RegionName[i].ComposeUse == true then -- для выбора блока регионов, жмём с Shift
          for c=1, #RegionName do
            if RegionName[c].ComposeCombine == true then
              last_us = RegionName[c].Index
            end
          end
          last_us = last_us
          if last_us then
            for d=1, #RegionName do
              if d>last_us and d<=i then
                if mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[d].ComposeCombine == false then
                  RegionName[d].ComposeCombine = true
                end
              end

              if d<=last_us and d>=i then
                if mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[d].ComposeCombine == true then
                  RegionName[d].ComposeCombine = false
                end
              end
            end
            last_us = nil
          else
            if mouseDown (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h) and RegionName[i].ComposeCombine == false then
              RegionName[i].ComposeCombine = true
            end
          end
        end

        if RegionName[i].ComposeCombine == true then
          DrawUsetStr (x+(h_s+2)*5+w_n, y+h_s/2, h_s, h," ]", 4)
        end

        if RegionName[i].ComposeUse == false then
          RegionName[i].ComposeCombine = false
        end
      end

      if RegionName[i].ComposeUse == false then
        SetRGB(0x000000,0.6)
        gfx.rect(10, y, w_n+h*5+6, h, 1)
        gfx.rect(x+(h_s+2)*5+w_n, y+h_s/2, h_s, h, 1)
      end
    end
    y = y + h + 2
  end

  RefreshList ()
  SongMove ()
end

function ScrollBar(x,y,w,h,total,visible,position)
  gfx.set(0.1)
  gfx.rect(x,y,w,h)
  SetRGB(0x24e915, 0.4)
  gfx.rect(x,y,w,h,0)
  -------------------
  local normval, sh, sy
  -------------------
  if position == 1 then normval = 0
  else normval = (position - 1)/(total-visible)
  end
  -------------------
  sh = (visible/total) * h      -- scroll bar h
  sh = math.min(math.max(sh, 20),h)
  sy = y + (h - sh) * normval -- scroll bar y
  SetRGB(0x5b9157, 0.25)
  gfx.rect(x+1, sy, w-2, sh, 1)

  if mouseDown(x+1, sy, w-2, sh) then
    m_down_scrol = true
  elseif mouse_up then
    m_down_scrol = false
  end

  local scroll_delay = 0.05
  if m_down_scrol then -- для скрола мышкой за скролбар
    SetRGB(0x5b9157, 0.35)
    gfx.rect(x+1, sy, w-2, sh, 1)
    if mouse_move_up then
      if RegionCapture.waitingScroll ~= true then
        RegionCapture.waitingScroll = true
        timeout(scroll_delay,function ()
          if RegionCapture.waitingScroll then
            ScrollTo(-1)
            RegionCapture.waitingScroll = false
          end
        end)
      end
    elseif mouse_move_down then
      if RegionCapture.waitingScroll ~= true then
        RegionCapture.waitingScroll = true
        timeout(scroll_delay,function ()
          if RegionCapture.waitingScroll then
            ScrollTo(1)
            RegionCapture.waitingScroll = false
          end
        end)
      end
    else
      RegionCapture.waitingScroll = false
    end
  end
end

function DrawScrollbar()
  maxRowsFit = (math.floor((gfx.h - h_cup) / (h_s+2)))

  if #RegionName > maxRowsFit then
    if gfx.mouse_wheel ~= 0 then
      s_position = s_position - round(gfx.mouse_wheel/120)
      gfx.mouse_wheel = 0
    end
    local maxScroll = #RegionName-maxRowsFit+1
    s_position = math.max(math.min(s_position,maxScroll),1)
    ScrollBar(10+(h_s+2)*6+w_n+2+4, h_cup, h_s-8,maxRowsFit*(h_s+2)-2,#RegionName,maxRowsFit,s_position)
  else
    s_position = 1
  end
end
----------------------------------------------------------------------------------------------------

function PlayStopGUIScript (char) -- чтоб работал Плэй-Стоп и Пауза при активном GUI скрипта тоже
  local play_state = reaper.GetPlayState()
  if char == 13 then -- Энтер
    if play_state == 1 or play_state == 5 then
      reaper.OnPauseButton()
    else
      reaper.OnPlayButton()
    end
  end

  if char == 32 then -- пробел
    if play_state == 1 or play_state == 5 then
      reaper.OnStopButton()
    else
      reaper.OnPlayButton()
    end
  end
end

function mainloop() -- запускается из Init
  PlayConcert()
  GetMouse()
  DrawScrollbar()
  DrawRows ()
  PresetsDraw()
  UpdateMouse()

  local char = gfx.getchar() -- символ с клавиатуры, а если =-1 - окно gfx закрыто
  if char~=-1 then reaper.defer(mainloop) end -- defer(пока окно открыто)
  PlayStopGUIScript (char)
  gfx.update() -- обновляет кадр
end
----------------------------------------------------------------------------------------------------
Init() -- Инициализируем окно
